Subject: bug#1757: 23.0.60; completion DWIM too clever

From: Richard M Stallman <[email-masked]>
Date: Thu, 01 Jan 2009 10:48:51 -0500

I typed C-x b *d TAB and it offered me as completions `diary' and `old',
neither of which starts with a `*'.

I typed C-x b *di TAB and it completed to `diary', which is not
even a completion of what I typed.

It is extremely annoying to discard the user's input characters.

In GNU Emacs 23.0.60.15 (mipsel-unknown-linux-gnu, GTK+ Version 2.12.11)
 of 2008-12-22 on lemote-yeeloong
configured using `configure  'CFLAGS=-O0 -g -Wno-pointer-sign' 'mipsel-unknown-linux-gnu' 'build_alias=mipsel-unknown-linux-gnu' 'host_alias=mipsel-unknown-linux-gnu' 'target_alias=mipsel-unknown-linux-gnu''

Important settings:
  value of $LC_ALL: nil
  value of $LC_COLLATE: nil
  value of $LC_CTYPE: nil
  value of $LC_MESSAGES: nil
  value of $LC_MONETARY: nil
  value of $LC_NUMERIC: nil
  value of $LC_TIME: nil
  value of $LANG: en_US.UTF-8
  value of $XMODIFIERS: nil
  locale-coding-system: utf-8-unix
  default-enable-multibyte-characters: t

Major mode: Diff

Minor modes in effect:
  diff-auto-refine-mode: t
  gpm-mouse-mode: t
  tooltip-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  global-auto-composition-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t
  abbrev-mode: t

Recent input:
ESC : b u f f e r - u n d o - l i s t RET C-x b RET 
TAB TAB ESC < C-s p m a i l - v i e w - b u f f e r 
C-s C-s C-s C-s C-s C-s C-s C-s C-s C-s C-n C-n C-n 
C-n C-n C-n C-n C-a C-p C-p C-p C-o TAB ( s e t q SPC 
b u f f e r - u n d o - l i s t SPC t ) C-x C-s C-x 
b RET ESC p u C-x C-s C-x b RET ESC C-x C-x b RET C-x 
k RET ESC x p m a i l RET y ESC : b u f f e r - s w 
a p p e d - w i t h RET C-d C-d C-d C-d C-d C-d p C-d 
C-d C-d x C-x C-s ESC : b u f f e r ESC p RET C-x d 
e m a c s - c v s / l i s p / m a i l / p m a i l * 
. e l * RET C-u C-n C-n C-n C-@ C-u C-n C-n C-n C-n 
C-n C-n = C-g C-x C-x = RET ESC C-v C-x 1 C-u C-n C-u 
C-n C-n C-p C-n C-@ C-p = RET ESC C-v ESC C-v ESC C-v 
ESC C-v ESC C-v ESC C-v C-x 1 C-x b * d i TAB DEL DEL 
DEL DEL DEL * d i TAB DEL DEL DEL DEL DEL * C-g C-x 
C-b C-x o C-v C-n C-n C-n f C-x 1 ESC x r e p o r t 
SPC e m a v s DEL DEL c s RET

Recent messages:
0 new messages read
#<buffer  *message-viewer PMAIL*>
Expunging deleted messages...done
Saving file /home/rms/PMAIL...
Wrote /home/rms/PMAIL
#<buffer  *message-viewer PMAIL*>
Mark set
Source file `/home/rms/emacs-cvs/lisp/diff.el' newer than byte-compiled file
Quit
Mark activated
Quit